<id>
Contact Page for YaBB 2.5
</id>

<version>
0.3
</version>

<mod info>
Description
-----------
Adds a Contact Page to your Forum.

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Upload ContactPageSettings.pl, ContactPage.lng and ContactPage.pl to their relevant directories in ASCII mode.
4) Upload contact.png and contact.gif to their relevant directories in binary mode.

Files to edit
-------------
AdminIndex.pl
Admin/AdminSublist.pl
Admin/ModList.pl
Languages/English/Admin.lng
Languages/English/Email.lng
Languages/English/Menu.lng
Sources/AdvancedTabs.pl
Sources/SubList.pl
Sources/Subs.pl
Sources/TabMenu.pl
Variables/Menu0.def
Variables/Menu1.def
Variables/Menu2.def
Variables/Settings.pl

Version History
---------------
V0.1 - First release - 16th January 2010
V0.2 - Added Spam Detection - 20th January 2010
V0.3 - Updated for YaBB 2.5 - 15th July 2010
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
$contactpage_mod = "contactpage|$mod_list{'contact'}|$mod_list{'contact1'}|";
push (@boardmod_mods, "$contactpage_mod");

</add before>

<edit file>
Admin/AdminSublist.pl
</edit file>

<search for>
'cleanerrorlog',"ErrorLog.pl&CleanErrorLog",
</search for>

<add after>
### Contact Page Mod Start ###
'contactpage',"ContactPageSettings.pl&ContactPage", 
'contactpage2',"ContactPageSettings.pl&ContactPage2",
### Contact Page Mod End ###
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$contactpage_mod = "Contact Page|Derek Barnstorm|Adds a Contact Page to your Forum. [<span class=\"small\"><a href=\"$adminurl?action=contactpage\" style=\"font-weight: bold;\">Contact Page Settings</a></span>]|0.3|15th July 2010";
	push (@installed_mods, "$contactpage_mod");
	
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
);

%smtp_txt = (
</search for>

<add before>
### Conatct Page Mod Start ###
'contact' => 'Contact Page Settings',
'contact1' => 'Edit Contact Page Settings',
### Contact Page Mod End ###
</add before>

<edit file>
Languages/English/Email.lng
</edit file>

<search for>
1;
</search for>

<add before>
### Contact Page Mod Start ###
$contactform = qq~Subject: {yabb contactsubject}
Name: {yabb yourname}
Email: {yabb youremail}
IP Address: {yabb contactip}
Message: 
{yabb contactmessage}~;

$contactform_selfcopy = qq~Subject: {yabb contactsubject}
Name: {yabb yourname}
Email: {yabb youremail}
Message: 
{yabb contactmessage}~;

$contactform_autorespond = qq~{yabb autoresponse}~;
### Contact Page Mod End ###

</add before>

<edit file>
Languages/English/Menu.lng
</edit file>

<search for>
);

%img_polltxt = (
</search for>

<add before>
'contact' => 'Contact', ### Conatct Page Mod ###
</add before>

<edit file>
Sources/AdvancedTabs.pl
</edit file>

<search for>
	$edittab{'logout'} = qq~<span $tabstyle>$tabfill$img_txt{'108'}$tabfill</span>~;
</search for>

<add after>
	$edittab{'contact'} = qq~<span $tabstyle>$tabfill$img_txt{'contact'}$tabfill</span>~; ### Contact Page Mod ###
</add after>

<search for>
	$texttab{'logout'} = $img_txt{'108'};
</search for>

<add after>
	$texttab{'contact'} = $img_txt{'contact'}; ### Contact Page Mod ###
</add after>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'collapse_cat',"BoardIndex.pl&Collapse_Cat",
</search for>

<add after>
### Contact Page Mod Start ###
'contact',"ContactPage.pl&Contact",
'contactsend',"ContactPage.pl&ContactSend",
### Contact Page Mod End ###
</add after>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
			$yymenu .= qq~$menusep<a href="$scripturl?action=logout">$img{'logout'}</a>~;
		}
</search for>

<add after>
        ### Contact Page Mod Start ###
		if (-e("$vardir/ContactPage.txt")) { require "$vardir/ContactPage.txt"; }
		if ($en_contactpage == 2 || (!$iamguest && $en_contactpage == 1)) {
			$yymenu .= qq~$menusep<a href="$scripturl?action=contact">$img{'contact'}</a>~;
		}
		### Contact Page Mod End ###
</add after>

<edit file>
Sources/TabMenu.pl
</edit file>

<search for>
		$tab{'logout'} = qq~<span |><a href="$scripturl?action=logout" title = "$img_txt{'108'}" style="padding: 3px 0 4px 0;">$tabfill$img_txt{'108'}$tabfill</a></span>~;
	}
</search for>

<add after>
    ### Contact Page Mod Start ###
	if (-e "$vardir/ContactPage.txt") { require "$vardir/ContactPage.txt"; }
	if ($en_contactpage == 2 || (!$iamguest && $en_contactpage == 1)) {
		$tab{'contact'} = qq~<span |><a href="$scripturl?action=contact" title = "$img_txt{'contact'}" style="padding: 3px 0 4px 0;">$tabfill$img_txt{'contact'}$tabfill</a></span>~;
	}
	### Contact Page Mod End ###
</add after>

<edit file>
Variables/Menu0.def
</edit file>

<search for>
'collapse' => "<img src=\"$imagesdir/cat_collapse.$imgext\" alt=\"$img_txt{'623'}\" title=\"$img_txt{'623'}\" border=\"0\" /> <span class=\"imgcatbg\">$img_txt{'623'}</span>",
</search for>

<add after>
'contact' => "<img src=\"$imagesdir/contact.$imgext\" alt=\"$img_txt{'contact'}\" title=\"$img_txt{'contact'}\" border=\"0\" /> <span class=\"imgmenu\">$img_txt{'contact'}</span>",
</add after>

<edit file>
Variables/Menu1.def
</edit file>

<search for>
'collapse' => "<span class=\"imgcatbg\">$img_txt{'623'}</span>",
</search for>

<add after>
'contact' => "<span class=\"imgmenu\">$img_txt{'contact'}</span>",
</add after>

<edit file>
Variables/Menu2.def
</edit file>

<search for>
'collapse' => "<img src=\"$yyhtml_root/Buttons/$button_language/collapse.$imgext\" alt=\"$img_txt{'623'}\" title=\"$img_txt{'623'}\" border=\"0\" />",
</search for>

<add after>
'contact' => "<img src=\"$yyhtml_root/Buttons/$button_language/contact.$imgext\" alt=\"$img_txt{'contact'}\" title=\"$img_txt{'contact'}\" border=\"0\" />",
</add after>

<edit file>
Variables/Settings.pl
</edit file>

<search for>
1;
</search for>

<add before>
push(@AdvancedTabs, "contact");

</add before>

