###############################################################################
# ContactPage.pl                                                              #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.5 Anniversary Edition                                #
# Packaged:       July 04, 2010                                               #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2010 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
###############################################################################

$contactpageplver = 'YaBB 2.5 AE $Revision: 0.3 $';
if ($action eq 'detailedversion') { return 1; }

require "$sourcedir/SpamCheck.pl";

if (-e("$vardir/ContactPage.txt")) { require "$vardir/ContactPage.txt"; }

if ($en_valimage == 2 || ($iamguest && $en_valimage == 1)) { require "$sourcedir/Decoder.pl"; }

if (!$en_contactpage || ($iamguest && $en_contactpage != 2)) { &fatal_error('not_allowed'); }

&LoadLanguage('ContactPage');

sub Contact {

    if (!$iamguest) { 
         $contactuser = qq~ value="${$uid.$username}{'realname'}" onfocus="txtInFields(this, '${$uid.$username}{'realname'}');" onblur="txtInFields(this, '${$uid.$username}{'realname'}')"~;
         $contactemail = qq~ value="${$uid.$username}{'email'}" onfocus="txtInFields(this, '${$uid.$username}{'email'}');" onblur="txtInFields(this, '${$uid.$username}{'email'}')"~; 
    }
    
    if ($contact_subjects) { $check_other = qq~ onfocus="CheckOtherSubject();"~; }
	
    @subjectoptions = split(/\|/, $contact_subjects);
    $subjectcount = 0;
    foreach (@subjectoptions) {
        $subjects .= qq~<label for="contact_subject$subjectcount"><input type="radio" name="contact_subject" id="contact_subject$subjectcount" value="$subjectcount" />$_</label><br />\n~;
        $subjectcount++;
    }

    # SpellChecker start
    if ($en_conspellcheck && $enable_spell_check) {
        $yyinlinestyle .= qq~<link href="$yyhtml_root/googiespell/googiespell.css" rel="stylesheet" type="text/css" />
<script type="text/javascript" src="$yyhtml_root/AJS.js"></script>
<script type="text/javascript" src="$yyhtml_root/googiespell/googiespell.js"></script>
<script type="text/javascript" src="$yyhtml_root/googiespell/cookiesupport.js"></script>~;
        my $userdefaultlang = (split(/-/, $abbr_lang))[0];
        $userdefaultlang ||= 'en';
        $contact_spellcheck .= qq~GOOGIE_DEFAULT_LANG = '$userdefaultlang';
var googie1 = new GoogieSpell("$yyhtml_root/googiespell/", "$boardurl/Sources/SpellChecker.pl?lang=");
googie1.lang_chck_spell = '$spell_check{'chck_spell'}';
googie1.lang_revert = '$spell_check{'revert'}';
googie1.lang_close = '$spell_check{'close'}';
googie1.lang_rsm_edt = '$spell_check{'rsm_edt'}';
googie1.lang_no_error_found = '$spell_check{'no_error_found'}';
googie1.lang_no_suggestions = '$spell_check{'no_suggestions'}';
googie1.setSpellContainer("spell_container");
googie1.decorateTextarea("contact_message");~;
        $contact_spelldiv = qq~<div id="spell_container"></div>~;
    }
    # SpellChecker end
	
    $yymain .= qq~
<form action="$scripturl?action=contactsend" method="post" name="contact" onsubmit="return CheckContactFields();">
<table width="100%" align="center" border="0" cellpadding="4" cellspacing="1" class="bordercolor">
 <colgroup>
  <col width="40%" />
  <col width="60%" />
 </colgroup>
 <tr>
  <th colspan="2" class="catbg" style="text-align: left;">
   <img src="$imagesdir/contact.gif" border="0" alt="" style="vertical-align: middle;" /> $contact_txt{'01'} $mbname
  </th>
 </tr>
 <tr>
  <td colspan="2" class="windowbg" style="text-align: center;">
   $contact_txt{'02'}
  </td>
 </tr>
 <tr>
  <td class="windowbg" style="text-align: right; vertical-align: top;">
   <label for="your_name">* <span style="font-weight: bold;">$contact_txt{'03'}:</span></label>
  </td>
  <td class="windowbg2">
   <input type="text" name="your_name" id="your_name" size="30" maxlength="50"$contactuser />
  </td>
 </tr>
 <tr>
  <td class="windowbg" style="text-align: right; vertical-align: top;">
   <label for="your_email">* <span style="font-weight: bold;">$contact_txt{'04'}:</span></label>
  </td>
  <td class="windowbg2">
   <input type="text" name="your_email" id="your_email" size="30" maxlength="100"$contactemail />
  </td>
 </tr>
 <tr>
  <td class="windowbg" style="text-align: right; vertical-align: top;">
   <label for="contact_subject">* <span style="font-weight: bold;">$contact_txt{'05'}:</span></label>
  </td>
  <td class="windowbg2">
   $subjects~;
   if ($contact_subjects) {
       $yymain .= qq~
   <label for="other"><input type="radio" name="contact_subject" id="other" value="other" onclick="FocusOtherSubject();" />$contact_txt{'06'}</label><br />~; 
   }
   $yymain .= qq~
   <input type="text" name="other_contact_subject" id="contact_subject" size="30" maxlength="80"$check_other />
  </td>
 </tr>
 <tr>
  <td class="windowbg" style="text-align: right; vertical-align: top;">
   <label for="contact_message">* <span style="font-weight: bold;">$contact_txt{'07'}:</span></label>
  </td>
  <td class="windowbg2">
   <div style="float: left;">
    <textarea cols="50" rows="10" name="contact_message" id="contact_message"></textarea>
   </div>
   $contact_spelldiv
   <div style="float: left; clear: both;">
    <span class="small">$contact_txt{'08'} <input value="$MaxConMesLen" size="3" name="msgCL" class="windowbg2" style="border: 0; width: 40px; padding: 1px; font-size: 11px;" readonly="readonly" /></span>
   </div>
  </td>
 </tr>~;
 if ($en_selfcopy) {
     $yymain .= qq~
 <tr>
  <td class="windowbg" style="text-align: right; vertical-align: top; font-weight: bold;">
   <label for="contact_selfcopy">$contact_txt{'09'}</label>
  </td>
  <td class="windowbg2">
   <input type="checkbox" name="contact_selfcopy" id="contact_selfcopy" />
  </td>
 </tr>~;
 }  
 if ($en_valimage == 2 || ($iamguest && $en_valimage == 1)) {
     &validation_code;
     $yymain .= qq~
 <tr>
   <td class="windowbg" style="text-align: right; vertical-align: top;">
    <label for="verification"><span style="font-weight: bold;">$floodtxt{'1'}:</span><br /><span class="small">$floodtxt{'casewarning'}</span></label>
   </td>
   <td class="windowbg2" style="vertical-align: middle;">
    $showcheck
  </td>
 </tr>
 <tr>
  <td class="windowbg" style="text-align: right; vertical-align: top;">
   <label for="verification">* <span style="font-weight: bold;">$floodtxt{'3'}:</span></label>
  </td>
  <td class="windowbg2">
   <input type="text" maxlength="30" name="verification" id="verification" size="30" />
  </td>
 </tr>~;
 }
 $yymain .= qq~
 <tr>
  <td colspan="2" class="catbg" style="height: 50px; text-align: center; vertical-align: middle;">
   <input type="submit" value="$contact_txt{'10'}" accesskey="s" class="button" />&nbsp;<input type="reset" value="$contact_txt{'11'}" accesskey="r" class="button" />
  </td>
 </tr>
</table>
</form>
<script type="text/javascript" language="JavaScript">
<!--
if (document.contact.your_name.value == '') {
    document.contact.your_name.focus();
}~ . ($contact_subjects ? qq~
function CheckOtherSubject() {
    document.getElementById('other').checked = true; 
}
function FocusOtherSubject() {
if (document.getElementById('other').checked == true) {
    document.contact.other_contact_subject.focus();
}
}~ : '') . qq~
function CheckContactFields() {
if (document.contact.your_name.value == '') {
    alert("$contact_txt{'12'}");
    document.contact.your_name.focus();
    return false;
}
if (document.contact.your_email.value == '') {
    alert("$contact_txt{'13'}");
    document.contact.your_email.focus();
    return false;
}~ . ($contact_subjects ? qq~
var subjects = 0;
for (var i=0; i < document.contact.contact_subject.length; i++) {
     if (document.contact.contact_subject[i].checked == true) {
         subjects++;
         break;
     } 
}
if (subjects == 0) {
    alert("$contact_txt{'14'}");
    document.getElementById('other').checked = true
    document.contact.other_contact_subject.focus();
    return false;
}
if (document.getElementById('other').checked == true && document.contact.other_contact_subject.value == '') {
    alert("$contact_txt{'15'}");
    document.contact.other_contact_subject.focus();
    return false;
}~ : qq~
if (document.contact.other_contact_subject.value == '') {
    alert("$contact_txt{'15'}");
    document.contact.other_contact_subject.focus();
    return false;
}~ ) . qq~
if (document.contact.contact_message.value == '') {
    alert("$contact_txt{'16'}");
    document.contact.contact_message.focus();
    return false;
}~ . ($en_valimage == 2  || ($iamguest && $en_valimage == 1) ? qq~
if (document.contact.verification.value == '') {
    alert("$contact_txt{'17'}");
    document.contact.verification.focus();
    return false;
}~ : '') . qq~
return true;
}

var supportsKeys = false;
function tick() {
    calcCharLeft(document.forms[0]);
    if (!supportsKeys) { timerID = setTimeout("tick()", 1500); }
}
function calcCharLeft() {
clipped = false;
maxLength = $MaxConMesLen;
if (document.contact.contact_message.value.length > maxLength) {
    document.contact.contact_message.value = document.contact.contact_message.value.substring(0,maxLength);
    charleft = 0;
    clipped = true;
} else {
    charleft = maxLength - document.contact.contact_message.value.length;
}
document.contact.msgCL.value = charleft;
return clipped;
}
tick();

$contact_spellcheck

// -->
</script>~;
	
	$yytitle = "$contact_txt{'01'}";
	$yynavigation = qq~&rsaquo; $contact_txt{'01'}~;
	&template;
}

sub ContactSend {

    require "$sourcedir/Mailer.pl";
    &LoadLanguage('Email');

    $yourname = $FORM{'your_name'};
    $youremail = $FORM{'your_email'};
    $contactsubject = $FORM{'contact_subject'};
    $othercontactsubject = $FORM{'other_contact_subject'};
    $contactmessage = $FORM{'contact_message'};
    $contactselfcopy = $FORM{'contact_selfcopy'};
    $yourname =~ s/\A\s+//;
    $yourname =~ s/\s+\Z//;
    $youremail =~ s/\A\s+//;
    $youremail =~ s/\s+\Z//;
    $contactsubject =~ s/\A\s+//;
    $contactsubject =~ s/\s+\Z//;
    $othercontactsubject =~ s/\A\s+//;
    $othercontactsubject =~ s/\s+\Z//;
    $contactmessage =~ s/\r(?=\n*)//g;
    $contact_auto =~ s~<br \/>~\n~g;
	
    $contact_email  ||= $webmaster_email;
    $selfcopy_email ||= $webmaster_email;
    $autores_email  ||= $webmaster_email;
    $selfcopy_name  ||= $mbname;
    $autores_name   ||= $mbname;
    $subject_pre    ||= "$contactpre_txt{'01'}";
    $selfcopy_pre   ||= "$contactpre_txt{'02'}";
    $autores_pre    ||= "$contactpre_txt{'03'}";
	
    @subjectoptions = split(/\|/, $contact_subjects);
	
    if ($contactsubject eq 'other' || !$contact_subjects) { $subject = $othercontactsubject } 
    else { $subject = $subjectoptions[$contactsubject]; }
    
    &fatal_error("no_name") if ($yourname eq '');
    &fatal_error("sendname_too_long") if (length($yourname) > 50);
    &fatal_error("no_email") if ($youremail eq '');
    &fatal_error("invalid_character","$contact_txt{'04'}.") if ($youremail !~ /[\w\-\.\+]+\@[\w\-\.\+]+\.(\w{2,4}$)/);
    &fatal_error("invalid_email") if (($youremail =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($youremail !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/));
    &fatal_error("email_to_long") if length($youremail) > 100;
    &fatal_error("no_subject") if ($contact_subjects && $contactsubject eq '');
    &fatal_error("no_subject") if ($contact_subjects && $contactsubject eq 'other' && $othercontactsubject eq '');
    &fatal_error("no_subject") if (!$contact_subjects && $othercontactsubject eq '');
    &fatal_error("no_message") if ($contactmessage eq '');
	
    # Spam detection start
    &email_domain_check($youremail); # Check if poster isn't using a distilled email domain
    my $spamdetected = &spamcheck("$yourname $youremail $othercontactsubject $contactmessage");
    if (!${$uid.$FORM{$username}}{'spamcount'}) { ${$uid.$FORM{$username}}{'spamcount'} = 0; }
    if (!$iamadmin && !$iamgmod && !$iammod) {
        if ($spamdetected == 1) {
            ${$uid.$username}{'spamcount'}++;
            ${$uid.$username}{'spamtime'} = $date;
            &UserAccount($username,"update");
            $spam_hits_left_count = $post_speed_count - ${$uid.$username}{'spamcount'};
            if ($spamdetected == 1) { &fatal_error("tsc_alert"); }
        }
    }
    # Spam detection end

    if ($en_valimage == 2 || ($iamguest && $en_valimage == 1)) { &validation_check($FORM{'verification'}); }
    
    my $contact_message = &template_email($contactform, {'yourname' => $yourname, 'contactsubject' => $subject, 'contactmessage' => $contactmessage, 'youremail' => $youremail, 'contactip' => $user_ip});
       &sendmail($contact_email, "$subject_pre: $subject", $contact_message, "$yourname <$youremail>"); 
 
    if ($contactselfcopy && $en_selfcopy) {
    my $copy_message = &template_email($contactform_selfcopy, {'yourname' => $yourname, 'contactsubject' => $subject, 'contactmessage' => $contactmessage, 'youremail' => $youremail});
       &sendmail($youremail, "$selfcopy_pre: $subject", $copy_message, "$selfcopy_name <$selfcopy_email>");
    }
	
    if ($en_contact_auto && $contact_auto) {
    my $autores_message = &template_email($contactform_autorespond, {'autoresponse' => $contact_auto});
       &sendmail($youremail, "$autores_pre: $subject", $autores_message, "$autores_name <$autores_email>");
    }
	
    $yymain .= qq~
<table width="100%" align="center" border="0" cellpadding="4" cellspacing="1" class="bordercolor">
 <tr>
  <th class="catbg" style="text-align: left;">
   <img src="$imagesdir/contact.gif" border="0" alt="" style="vertical-align: middle;" /> $contact_txt{'01'} $mbname
  </th>
 </tr>
 <tr>
  <td class="windowbg" style="padding: 20px; text-align: center; vertical-align: middle;">
   <span style="font-weight: bold;">$contact_txt{'18'} $yourname.<br />$contact_txt{'19'}</span><br /><br />
   &bull; <a href="$scripturl">$contact_txt{'20'}</a><br /><br />
   <span class="small">$contact_txt{'21'}</span>
  </td>
 </tr>
</table>~;

    $yyinlinestyle = qq~<meta http-equiv="refresh" content="5; url=$scripturl" />~;
    $yytitle = "$contact_txt{'01'} - $contact_txt{'22'}";
    $yynavigation = qq~&rsaquo; $contact_txt{'01'} &rsaquo; $contact_txt{'22'}~;
    &template;
}

1;